@ECHO OFF
rem ===========================================================================
rem megaboot.bat ϰϴ ̽(ҹڷθ Ѵ.)
rem megaboot.bat ̽   ⺻ atmega128 õȴ.
rem ex) megaboot.bat atmega2560
rem ===========================================================================


title MegaBoot Compiler

set CC=avr-gcc
set OBJ=avr-objcopy
set SIZE=avr-size

rem BOOT_SIZE_W ǥ ڷ 
set BOOT_SIZE_W=0x0
rem BOOT_SIZE Ͽ  & ǥ ڷ 
set BOOT_SIZE=0x0

rem WinAVR Compiler Default Directory
set AVR=c:\WinAVR\

set PATH=%AVR%\bin;%AVR%\utils\bin;%AVR%\avr\include;%AVR%\avr\include\avr;

rem DEVICE Choice
if '%1'=='' (
  set MCU=atmega128
)else (
  set MCU=%1
)


rem ATmega2561 Setup
if '%MCU%' == 'atmega2560' (
set BOOT_SIZE_W=0x1FC00
set BOOT_SIZE=0x3F800
rem set BOOT_SIZE_W=0x1F800
rem set BOOT_SIZE=0x3F000
)

rem ATmega2560 Setup
if '%MCU%' == 'atmega2560' (
set BOOT_SIZE_W=0x1FC00
set BOOT_SIZE=0x3F800
rem set BOOT_SIZE_W=0x1F800
rem set BOOT_SIZE=0x3F000
)


rem ATmega1281 Setup
if '%MCU%' == 'atmega1280' (
set BOOT_SIZE_W=0xFC00
set BOOT_SIZE=0x1F800
rem set BOOT_SIZE_W=0xF800
rem set BOOT_SIZE=0x1F000
)

rem ATmega1280 Setup
if '%MCU%' == 'atmega1280' (
set BOOT_SIZE_W=0xFC00
set BOOT_SIZE=0x1F800
rem set BOOT_SIZE_W=0xF800
rem set BOOT_SIZE=0x1F000
)

rem ATmega640 Setup
if '%MCU%' == 'atmega640' (
set BOOT_SIZE_W=0x7C00
set BOOT_SIZE=0xF800
rem set BOOT_SIZE_W=0x7800
rem set BOOT_SIZE=0xF000
)


rem ATmega8535 Setup
if '%MCU%' == 'atmega8535' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

rem ATmega8515 Setup
if '%MCU%' == 'atmega8515' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

rem ATmega169 Setup
if '%MCU%' == 'atmega169' (
set BOOT_SIZE_W=0x1C00
set BOOT_SIZE=0x3800
)

rem ATmega168 Setup
if '%MCU%' == 'atmega168' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

rem ATmega165 Setup
if '%MCU%' == 'atmega165' (
set BOOT_SIZE_W=0x1C00
set BOOT_SIZE=0x3800
)


rem ATmega162 Setup
if '%MCU%' == 'atmega162' (
set BOOT_SIZE_W=0x1C00
set BOOT_SIZE=0x3800
)

rem ATmega128 Setup
if '%MCU%' == 'atmega128' (
set BOOT_SIZE_W=0xFC00
set BOOT_SIZE=0x1F800
)

rem ATmega64 Setup
if '%MCU%' == 'atmega64' (
set BOOT_SIZE_W=0x7000
set BOOT_SIZE=0xE000
)

rem ATmega88 Setup
if '%MCU%' == 'atmega88' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

rem ATmega48 Setup
if '%MCU%' == 'atmega48' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

rem ATmega32 Setup
if '%MCU%' == 'atmega32' (
set BOOT_SIZE_W=0x3C00
set BOOT_SIZE=0x7800
)

rem ATmega16 Setup
if '%MCU%' == 'atmega16' (
set BOOT_SIZE_W=0x1C00
set BOOT_SIZE=0x3800
)

rem ATmega8 Setup
if '%MCU%' == 'atmega8' (
set BOOT_SIZE_W=0xC00
set BOOT_SIZE=0x1800
)

if %BOOT_SIZE%==0x0 GOTO NoDevice

ECHO ******* %MCU% *******(%BOOT_SIZE_W%)-%BOOT_SIZE% 

%CC% -mmcu=%MCU% -gdwarf-2 -std=gnu99 -Wall -W -Wstrict-prototypes -Wall -Os -Wl,-M,--section-start=.text=%BOOT_SIZE% -Wl,-Map,MegaBoot.map MegaBoot.c -o MegaBoot.elf

IF ERRORLEVEL 1 GOTO FAIL

%OBJ% --output-target=ihex MegaBoot.elf MegaBoot.hex
rem %OBJ% --output-target=binary MegaBoot.o MegaBoot.bin

%SIZE% --mcu=%MCU% --format=avr MegaBoot.elf

GOTO END

:NoDevice
ECHO unknown MCU '%MCU%' specified
ECHO Known MCU names:
ECHO    atmega8
ECHO    atmega48
ECHO    atmega88
ECHO    atmega8515
ECHO    atmega8535
ECHO    atmega16
ECHO    atmega162
ECHO    atmega165
ECHO    atmega168
ECHO    atmega169
ECHO    atmega32
ECHO    atmega64
ECHO    atmega128
ECHO    atmega640
ECHO    atmega1280
ECHO    atmega1281
ECHO    atmega2560
ECHO    atmega2561
ECHO.

rem GOTO END
:FAIL

ECHO ERROR !!!
:END

PAUSE
