/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/

//*****************************************************************************
//* BootLoader V1.0 for MegaBoot V1.2
//*****************************************************************************


//****************************************************************************/

//* 2005-12-24 : Version 1.0

//* 2007-10-02 : Version 1.1

//* 2008-01-07 : Version 1.2
//*				 ExecCode() κп 0  ҽ 
//*				 Wait() Լ  - WinAVR-20071221   .
//*				 ATMega640, 1280, 1281, 2560, 2561 ߰

//*****************************************************************************

// ATMega128.............Test Ok! (64K Over Code Ȯ, 16M 115200bps  Ȯ)
// ATMega64..............Test Ok!
// ATMega16..............Test Ok! (8M 57600bps  Ȯ)
// ATMega8...............Test Ok!
// ATMega2560............Test Ok! (16M 115200bps )


// ATMega48..............not tested, please give me feedback!
// ATMega88..............not tested, please give me feedback!
// ATMega162.............not tested, please give me feedback!
// ATMega168.............not tested, please give me feedback!
// ATMega169.............not tested, please give me feedback!
// ATMega640.............not tested, please give me feedback!
// ATMega1280............not tested, please give me feedback!
// ATMega1281............not tested, please give me feedback!
// ATMega2561............not tested, please give me feedback!

//*****************************************************************************


#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/boot.h>



#define  FALSE		0
#define  TRUE		1

#define  OFF		0
#define  ON			1



//*****************************************************************************
// MCU selection
//*****************************************************************************

#ifdef __AVR_ATmega8__
#define MEGATYPE	8		// ATmega8
#endif

#ifdef __AVR_ATmega16__
#define MEGATYPE  16		// ATmega16
#endif

#ifdef __AVR_ATmega32__
#define MEGATYPE  32		// ATmega32
#endif


#ifdef __AVR_ATmega48__
#define MEGATYPE  48		// ATmega48
#endif


#ifdef __AVR_ATmega64__
#define MEGATYPE  64		// ATmega64
#endif

#ifdef __AVR_ATmega88__
#define MEGATYPE  88		// ATmega88
#endif


#ifdef __AVR_ATmega128__
#define MEGATYPE  128		// ATmega128
#endif

#ifdef __AVR_ATmega162__
#define MEGATYPE  162		// ATmega162
#endif

#ifdef __AVR_ATmega165__
#define MEGATYPE  165		// ATmega165
#endif

#ifdef __AVR_ATmega168__
#define MEGATYPE  168		// ATmega168
#endif

#ifdef __AVR_ATmega169__
#define MEGATYPE  169		// ATmega169
#endif

#ifdef __AVR_ATmega8515__
#define MEGATYPE  8515		// ATmega8515
#endif

#ifdef __AVR_ATmega8535__
#define MEGATYPE  8535		// ATmega8535
#endif


#ifdef __AVR_ATmega640__
#define MEGATYPE  640		// ATmega640
#endif


#ifdef __AVR_ATmega1280__
#define MEGATYPE  1280		// ATmega1280
#endif

#ifdef __AVR_ATmega1281__
#define MEGATYPE  1281		// ATmega1281
#endif


#ifdef __AVR_ATmega2560__
#define MEGATYPE  2560		// ATmega2560
#endif

#ifdef __AVR_ATmega2561__
#define MEGATYPE  2561		// ATmega2561
#endif



//*****************************************************************************
// Crystal speed
// frequancy of your MCU speed
//*****************************************************************************
#define CPU_CLK			16000000L		// Clock 16Mhz
//#define CPU_CLK			8000000L		// Clock 8Mhz


//*****************************************************************************
// Bootload on UART x	( UART Ʈ )
// ATmega64, 128, 162, 1281, 2561 = UART 2PORT
// ATmega640, 1280, 2560 = UART 4PORT
//
// ̿  ̽ Ʈ ϳ̹Ƿ   ʿ.
//*****************************************************************************
#define UART        0
//#define UART       1
//#define UART       2
//#define UART       3


//*****************************************************************************
// BaudRate
// If you don't specify the baudrate divisor the bootloader
// will automaticaly be in AutoBaudRate mode
//*****************************************************************************

//  Ʈ
//  Ҽ ũô AutoBaudRate Ѵ.
// 16Mhz
//#define BAUDRATE     8		// 115200bps
//#define BAUDRATE     16		// 57600bps
//#define BAUDRATE     25		// 38400bps
//#define BAUDRATE     51		// 19200bps
//#define BAUDRATE     103		// 9600bps


//8Mhz
//#define BAUDRATE     3		// 115200bps
//#define BAUDRATE     8		// 57600bps
//#define BAUDRATE     12		// 38400bps
//#define BAUDRATE     25		// 19200bps
//#define BAUDRATE     51		// 9600bps


// ڵ Ʈ
#if (CPU_CLK == 16000000L)
#define  B9600		103
#define  B19200		51
#define  B38400		25
#define  B57600		16
#define  B115200	8
#endif

#if (CPU_CLK == 8000000L)
#define  B9600		51
#define  B19200		25
#define  B38400		12
#define  B57600		8
#define  B115200	3
#endif


/*
// UART Definitions
//these two defines establish the baud rate
// quartz crystal frequency [Hz]
// Baud rate
#define baud 19200
#define UBRRLO_VALUE ((CPU_CLK/16/baud-1)&0xFF)
#define UBRRHI_VALUE ((CPU_CLK/16/baud-1)>>8)
*/



//*****************************************************************************
// EEprom programming
// enable EEprom programing via bootloader
// YOU MUST SET TO 1024 WORD THE BOOTLOADER SIZE IF EEPROM
// PROGRAMMING IS USE
//*****************************************************************************
#define EEPROM




#define SETTINGBIT	// FUSESBIT , LOCKBIT б

//*****************************************************************************
// LockBit programming
// enable LOCKBIT programing via bootloader
//*****************************************************************************
#define LOCKBIT

//*****************************************************************************
// FusesBit programming
// enable FUSESBIT programing via bootloader
//*****************************************************************************
#define FUSESBIT


// LockBit 
#define	BLB12	5
#define	BLB11	4
#define	BLB02	3
#define	BLB01	2
#define LB2		1
#define LB1		0




//*****************************************************************************
// Device ID
//*****************************************************************************

#define Mega8           'A'
#define Mega16          'B'
#define Mega32          'E'
#define Mega48          'L'
#define Mega64          'C'
#define Mega88          'M'
#define Mega128         'D'
#define Mega162         'F'
#define Mega165         'G'
#define Mega168         'H'
#define Mega169         'I'
#define Mega8515        'J'
#define Mega8535        'K'
#define Mega640			0x81
#define Mega1280        0x82
#define Mega1281        0x83
#define Mega2560        0x84
#define Mega2561        0x85


#define Flash1k         'g'
#define Flash2k         'h'
#define Flash4k         'i'
#define Flash8k         'l'
#define Flash16k        'm'
#define Flash32k        'n'
#define Flash64k        'o'
#define Flash128k       'p'
#define Flash256k       'q'
#define Flash40k        'r'

#define EEprom64        '.'
#define EEprom128       '/'
#define EEprom256       '0'
#define EEprom512       '1'
#define EEprom1024      '2'
#define EEprom2048      '3'
#define EEprom4096      '4'

#define Boot128         'a'
#define Boot256         'b'
#define Boot512         'c'
#define Boot1024        'd'
#define Boot2048        'e'
#define Boot4096        'f'

#define Page32          'Q'
#define Page64          'R'
#define Page128         'S'
#define Page256         'T'
#define Page512         'V'


#if !(defined MEGATYPE)
#error "Processor Type is Undefined"
#endif

#if (((MEGATYPE==64)||(MEGATYPE == 128)||(MEGATYPE == 162)||(MEGATYPE == 1281)||(MEGATYPE == 2561)||(MEGATYPE == 640)||(MEGATYPE == 1280)||(MEGATYPE == 2560)) &&!(defined UART))
#error "UART ch must be defined for this part"
#endif





#ifdef __AVR_ATmega8__
#define  DeviceID       Mega8
#define  FlashSize      Flash8k
#define  PageSize       Page64
#define  EEpromSize     EEprom512
#define  PageByte       64
#define  NSHIFTPAGE     6
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif


#ifdef __AVR_ATmega16__
#define  DeviceID       Mega16
#define  FlashSize      Flash16k
#define  PageSize       Page128
#define  EEpromSize     EEprom512
#define  PageByte       128
#define  NSHIFTPAGE     7
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xff80		// page128 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x1C00) = 0x3800
#endif


#ifdef __AVR_ATmega32__
#define  DeviceID       Mega32
#define  FlashSize      Flash32k
#define  PageSize       Page128
#define  EEpromSize     EEprom1024
#define  PageByte       128
#define  NSHIFTPAGE     7
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xff80		// page128 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x3C00) = 0x7800
#endif


#ifdef __AVR_ATmega48__
#define  DeviceID       Mega48
#define  FlashSize      Flash4k
#define  PageSize       Page64
#define  EEpromSize     EEprom256
#define  PageByte       64
#define  NSHIFTPAGE     6
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif


#ifdef __AVR_ATmega88__
#define  DeviceID       Mega88
#define  FlashSize      Flash8k
#define  PageSize       Page64
#define  EEpromSize     EEprom512
#define  PageByte       64
#define  NSHIFTPAGE     6
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif




#ifdef __AVR_ATmega64__
#define  DeviceID       Mega64
#define  FlashSize      Flash64k
#define  PageSize       Page256
#define  EEpromSize     EEprom2048
#define  PageByte       256
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x7000)-0xE000
#endif




#ifdef __AVR_ATmega128__
#define  DeviceID       Mega128
#define  FlashSize      Flash128k
#define  PageSize       Page256
#define  EEpromSize     EEprom4096
#define  PageByte       256
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR
#define  RAMPZ_FLAG 

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xFC00) = 0x1F800
#endif



#ifdef __AVR_ATmega162__
#define	 DeviceID		Mega162
#define	 FlashSize		Flash16k
#define	 PageSize		Page128		
#define  PageByte		128
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		7
#define  INTVECREG      GICR
#if (UART == 0)
#define  PULLUPPORT		PORTD
#define  PULLUPPIN		0x01
#endif 
#if (UART == 1)
#define  PULLUPPORT		PORTB
#define  PULLUPPIN		0x04
#endif 
#define	 EXECCODE		0xff80		// page128 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x1C00) = 0x3800
#endif



#ifdef __AVR_ATmega165__
#define	 DeviceID		Mega165
#define	 FlashSize		Flash16k
#define	 PageSize		Page128		
#define  PageByte		128
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		7
#define  INTVECREG      MCUCR
#define  PULLUPPORT     PORTE
#define  PULLUPPIN      0x01
#define	 EXECCODE		0xff80		// page128 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x1C00) = 0x3800
#endif



#ifdef __AVR_ATmega168__
#define	 DeviceID		Mega168
#define	 FlashSize		Flash8k
#define	 PageSize		Page64	
#define  PageByte		64
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		6
#define  INTVECREG      MCUCR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif



#ifdef __AVR_ATmega169__
#define	 DeviceID		Mega169
#define	 FlashSize		Flash16k
#define	 PageSize		Page128		
#define  PageByte		128
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		7
#define  INTVECREG      MCUCR
#define  PULLUPPORT     PORTE
#define  PULLUPPIN      0x01
#define	 EXECCODE		0xff80		// page128 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0x1C00) = 0x3800
#endif



#ifdef __AVR_ATmega8515__
#define	 DeviceID		Mega8515
#define	 FlashSize		Flash8k
#define	 PageSize		Page64		
#define  PageByte		64
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		6
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif



#ifdef __AVR_ATmega8535__
#define	 DeviceID		Mega8535
#define	 FlashSize		Flash8k
#define	 PageSize		Page64		
#define  PageByte		64
#define	 EEpromSize		EEprom512
#define  NSHIFTPAGE		6
#define  INTVECREG      GICR
#define  PULLUPPORT     PORTD
#define  PULLUPPIN      0x01
#define  EXECCODE		0xffc0		// page64 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024	// (0xC00) = 0x1800
#endif



#ifdef __AVR_ATmega1280__
#define  DeviceID       Mega1280
#define  FlashSize      Flash128k
#define  PageSize       Page256
#define  EEpromSize     EEprom4096
#define  PageByte       256
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR
#define  RAMPZ_FLAG 

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#if (UART == 2)
#define PULLUPPORT      PORTH
#define PULLUPPIN       0x01
#endif
#if (UART == 3)
#define PULLUPPORT      PORTJ
#define PULLUPPIN       0x01
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024
#endif

#ifdef __AVR_ATmega1281__
#define  DeviceID       Mega1281
#define  FlashSize      Flash128k
#define  PageSize       Page256
#define  EEpromSize     EEprom4096
#define  PageByte       256
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR
#define  RAMPZ_FLAG 

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024
#endif


#ifdef __AVR_ATmega2560__
#define  DeviceID       Mega2560
#define  FlashSize      Flash256k
#define  PageSize       Page256		//Page128...
#define  EEpromSize     EEprom4096
#define  PageByte       256			//128...
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR
#define  RAMPZ_FLAG 

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#if (UART == 2)
#define PULLUPPORT      PORTH
#define PULLUPPIN       0x01
#endif
#if (UART == 3)
#define PULLUPPORT      PORTJ
#define PULLUPPIN       0x01
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024
#endif


#ifdef __AVR_ATmega2561__
#define  DeviceID       Mega2561
#define  FlashSize      Flash256k
#define  PageSize       Page256
#define  EEpromSize     EEprom4096
#define  PageByte       256
#define  NSHIFTPAGE     8
#define  INTVECREG      MCUCR
#define  RAMPZ_FLAG 

#if (UART == 0)
#define PULLUPPORT      PORTE
#define PULLUPPIN       0x01
#endif
#if (UART == 1)
#define PULLUPPORT      PORTD
#define PULLUPPIN       0x04
#endif
#define	 EXECCODE		0xff00		// page256 
// SELECTION DU BOOT SIZE
#define  BootSize       Boot1024
#endif





// Serial Port defenition
/*
#ifndef UDR
	#if (UART == 0)
	#define  UCSRA          UCSR0A
	#define  UCSRB          UCSR0B
	#define  UCSRC          UCSR0C
	#define  UBRRL          UBRR0L
	#define  UBRRH          UBRR0H
	#define  UDR            UDR0
	#endif

	#if (UART == 1)
	#define  UCSRA          UCSR1A
	#define  UCSRB          UCSR1B
	#define  UCSRC          UCSR1C
	#define  UBRRL          UBRR1L
	#define  UBRRH          UBRR1H
	#define  UDR            UDR1
	#endif
#endif
*/

#if ((MEGATYPE==64)||(MEGATYPE == 128)||(MEGATYPE == 162)||(MEGATYPE == 1281)||(MEGATYPE == 2561))
  #if (UART == 0)
	#define  UCSRA          UCSR0A
	#define  UCSRB          UCSR0B
	#define  UCSRC          UCSR0C
	#define  UBRRL          UBRR0L
	#define  UBRRH          UBRR0H
	#define  UDR            UDR0
  #endif
  #if (UART == 1)
	#define  UCSRA          UCSR1A
	#define  UCSRB          UCSR1B
	#define  UCSRC          UCSR1C
	#define  UBRRL          UBRR1L
	#define  UBRRH          UBRR1H
    #define  UDR            UDR1
  #endif
#endif



#if ((MEGATYPE == 640)||(MEGATYPE == 1280)||(MEGATYPE == 2560))
  #if (UART == 0)
	#define  UCSRA          UCSR0A
	#define  UCSRB          UCSR0B
	#define  UCSRC          UCSR0C
	#define  UBRRL          UBRR0L
	#define  UBRRH          UBRR0H
	#define  UDR            UDR0
  #endif
  #if (UART == 1)
	#define  UCSRA          UCSR1A
	#define  UCSRB          UCSR1B
	#define  UCSRC          UCSR1C
	#define  UBRRL          UBRR1L
	#define  UBRRH          UBRR1H
    #define  UDR            UDR1
  #endif
  #if (UART == 2)
	#define  UCSRA          UCSR2A
	#define  UCSRB          UCSR2B
	#define  UCSRC          UCSR2C
	#define  UBRRL          UBRR2L
	#define  UBRRH          UBRR2H
    #define  UDR            UDR2
  #endif
  #if (UART == 3)
	#define  UCSRA          UCSR3A
	#define  UCSRB          UCSR3B
	#define  UCSRC          UCSR3C
	#define  UBRRL          UBRR3L
	#define  UBRRH          UBRR3H
    #define  UDR            UDR3
  #endif
#endif




/*
#if (!(defined UART) || (UART == 0))
    #define _RX_INLINE
#endif


#ifdef  _RX_INLINE
#define     IsChar()    (UCSRA & 0x80)
#define     RxChar()    UDR
#endif
*/

/*****************************************************************************/
// Host
// define jump to bootloader command
#define BOOTLOADER_JUMP_CHAR '$'

/*****************************************************************************/
// BootLoader
// define flash program
#define FLASH_PROGRAM_CHAR '('
// define eeprom program
#define EEPROM_PROGRAM_CHAR ')'
// define bootloader ready for file character
#define READY_CHAR '?'
// define bootloader active char
#define BOOTLOADER_ACTIVE_CHAR '^'
// define line complete with no error character
#define LINE_COMPLETE_CHAR '~'	//   
// define checksum error character
#define CS_ERROR_CHAR '-'		// ŵ ࿡ üũ  
// define check flash error character
#define CF_ERROR_CHAR '%'		//   , ׷ ÷   ִ.
// define file complete, no errors character
#define FILE_COMPLETE_CHAR '@'
// define file complete, with errors character
#define FILE_ERROR_CHAR '#'


// define lock bit program
#define LOCKBIT_PROGRAM_CHAR '&'


// define AUTO BAUDRATE PING
#define AUTO_BAUDRATE_PING_CHAR 0x55

/*****************************************************************************/
/*                        P R O T O T Y P E                                  */
/*****************************************************************************/
//#ifndef  _RX_INLINE
unsigned char IsChar(void);
unsigned char RxChar(void);
//#endif
void TxChar(unsigned char ch);
void Wait(unsigned int loop);

void SendDeviceID(void);
void FlashLoad(void);
void GetPageNumber(void);
char GetPage(void);
void WriteFlash(void);
char CheckFlash(void);
char AutoFindBaudrate(void);
char AutoFindTx(int wait_time);

void EEpromLoad(void);
void EEPROMwrite(int location, unsigned char byte);
unsigned char EEPROMread(int location);

void LockBit(void);

void SettingBitRead(void);	// FusesBit LockBit   


void ExecCode(void);


/*****************************************************************************/
/*                G L O B A L    V A R I A B L E S                           */
/*****************************************************************************/
unsigned char PageBuffer[PageByte];

unsigned char RampzFlag;
#ifdef RAMPZ_FLAG
unsigned long PageAddress;
#else
unsigned int PageAddress;
#endif

/*
#if (MEGATYPE == 128)
unsigned int RealPageAddress;
#endif
*/

unsigned int RealPageAddress;

unsigned int RxWait;





/*****************************************************************************
  SUB-RUTINE..: IsChar
  Function....:  / Ȯ
******************************************************************************/
//#ifndef  _RX_INLINE
unsigned char IsChar(void)
{
  if(UCSRA & 0x80) return 1;
  else return 0;
}
//#endif
/*****************************************************************************
  SUB-RUTINE..: RxChar
  Function....:  Ÿ Ѵ.
******************************************************************************/
//#ifndef  _RX_INLINE
unsigned char RxChar(void)
{
  return UDR;
}
//#endif
/*****************************************************************************
  SUB-RUTINE..: TxChar
  Function....:  Ʈ 
******************************************************************************/
void TxChar(unsigned char ch)
{
  while(!(UCSRA & 0x20));           // wait for empty transmit buffer
  UDR = ch;                         // write char
}



/*****************************************************************************
  SUB-RUTINE..: Wait
  Function....:  ð 
******************************************************************************/
void Wait(unsigned int loop)
{
  unsigned long i;
  unsigned int j;

/*
  for(j=0;j<loop;j++) 
  { 
  #if(CPU_CLK < 8000000) 
    for (i=0;i<32000;i++)
    {	//250ns
		asm volatile(" PUSH  R0 ");
		asm volatile(" POP   R0 ");
    }
  #else 
    for (i=0;i<64000;i++)
	{	//250ns
		asm volatile(" PUSH  R0 ");
		asm volatile(" POP   R0 ");
	}
  #endif 
  } 
*/


  // WinAVR 2007 
  for(j=0;j<loop;j++) 
  { 
  #if(CPU_CLK < 8000000) 
    for (i=0;i<1600;i++) asm volatile(""); 
  #else 
    for (i=0;i<3200;i++) asm volatile(""); 
  #endif 
  } 


/*
//   
  for(j=0;j<loop;j++)
  {
  #if(CPU_CLK < 8000000)
    for (i=0;i<32000;i++);
  #else
	for (i=0;i<64000;i++);
  #endif
  }
*/


}



/****************************************************************************
  RUTINE......: SendDeviceID
  Function....: MCU  Ѵ.
****************************************************************************/
void SendDeviceID(void)
{
//#ifdef  _RX_INLINE
  unsigned char i;
//#endif
  TxChar(DeviceID);		// MCU 
  TxChar(FlashSize);	// ÷ ޸ 
  TxChar(BootSize);		// Ʈε ޸ 
  TxChar(PageSize);		//  
  TxChar(EEpromSize);	// EEPROM ޸ 
/*
#ifdef  _RX_INLINE
  i = RxChar();
#else
  RxChar();				// dummy read
#endif
*/
  i = RxChar();

}



/****************************************************************************
  RUTINE......: FlashLoad
  Function....: Flash Programing Code
****************************************************************************/
void FlashLoad(void)
{
  TxChar(FLASH_PROGRAM_CHAR);	// Flash α׷
  TxChar(READY_CHAR);			// ȣƮ  ͸ ϶..
  
  while(1)
  {
    GetPageNumber();	//  ȣ 

/*
#if (MEGATYPE == 128)
    if (RealPageAddress == 0xffff) return;
#else
    if (PageAddress == 0xffff) return;
#endif
*/
    if(RealPageAddress == 0xffff) return;
    //if(PageAddress == EXECCODE) return;


	if(GetPage())		//  Ÿ 
	{
	  WriteFlash();

	  if(CheckFlash())	//  ÷ ͸ Ͽ  / Ȯ.
	    TxChar(LINE_COMPLETE_CHAR);	// ̻,   䱸
	  else
		TxChar(CF_ERROR_CHAR);		// ,  䱸
	}
	else
	{
	  TxChar(CS_ERROR_CHAR);
	}
  }
}

/*****************************************************************************
  SUB-RUTINE..: GetPageNumber
  Function....:  ȣ Ѵ.
******************************************************************************/
void GetPageNumber(void)
{
  // 2007-10-03 	
/*
#if (MEGATYPE == 128)  
  unsigned char PageAddressHigh;
  unsigned char PageAddressLow;

  while(!IsChar());
  PageAddressHigh = RxChar();	// 巹  Ʈ Է ޴´.

  while(!IsChar());
  PageAddressLow = RxChar();	// 巹  Ʈ Է ޴´.

  RealPageAddress = ((unsigned int)PageAddressHigh << 8) + PageAddressLow;
  PageAddress = (unsigned long)RealPageAddress << NSHIFTPAGE;
  
#else	// Atmea8, 16, 32 at 64  
  while(!IsChar());
  PageAddress = RxChar() << 8;

  while(!IsChar());
  PageAddress += RxChar();
  PageAddress = PageAddress << NSHIFTPAGE; // NSHIFTPAGE  selon les cas  
#endif
*/

  
  unsigned char PageAddressHigh;
  unsigned char PageAddressLow;

  while(!IsChar());
  PageAddressHigh = RxChar();	// 巹  Ʈ Է ޴´.

  while(!IsChar());
  PageAddressLow = RxChar();	// 巹  Ʈ Է ޴´.

  RealPageAddress = ((unsigned int)PageAddressHigh << 8) + PageAddressLow;
  PageAddress = (unsigned long)RealPageAddress << NSHIFTPAGE;


  /*
  #ifdef RAMPZ_FLAG
  if (PageAddressHigh) RAMPZ = 1;
  else RAMPZ = 0;
  #endif
  */
}

/*****************************************************************************
  SUB-RUTINE..: GetPage
  Function....:   Ÿ  üũϿ  / Ѵ.
******************************************************************************/
char GetPage(void)
{
  unsigned int i;
  unsigned char LocalCheckSum = 0;
  unsigned char CheckSum = 0;

  for (i=0;i<PageByte;i++)
  {
    while(!IsChar());
	PageBuffer[i] = RxChar();
	LocalCheckSum += PageBuffer[i];
  }
		   
  while(!IsChar());
  CheckSum = RxChar(); 


  if(LocalCheckSum == CheckSum) return 1;
  else return 0;
}


/*****************************************************************************
  SUB-RUTINE..: WriteFlash
  Function....: 
******************************************************************************/
void WriteFlash(void)
{
  unsigned int i;
  unsigned int TempInt;
 
  // 2007-10-02 
  eeprom_busy_wait ();

  boot_page_erase(PageAddress);					//   .
  //while(boot_rww_busy()) boot_rww_enable();		//  ɶ .
  boot_spm_busy_wait ();      // Wait until the memory is erased.
  
  for(i=0;i<PageByte;i+=2)
  {
    TempInt = PageBuffer[i] + ((unsigned int)(PageBuffer[i+1]<<8));

 #ifdef RAMPZ_FLAG
   	  boot_page_fill((unsigned long)i,TempInt);
 #else
	  boot_page_fill(i,TempInt);
 #endif
  }
  
  boot_page_write(PageAddress);		// Store buffer in flash page. ( ȣ Writing)
  //while(boot_rww_busy()) boot_rww_enable();		// Ͱ  Writingɶ .
  boot_spm_busy_wait();       // Wait until the memory is written.
  // Reenable RWW-section again. We need this if we want to jump back
  // to the application after bootloading.
  boot_rww_enable ();



}


/*****************************************************************************
  SUB-RUTINE..: CheckFlash
  Function....: flash Writ ͸ readϿ ̻ Writ Ǿ Ȯ
******************************************************************************/
char CheckFlash(void)
{
  unsigned int i;							
  unsigned int TempInt = 0;
  unsigned int TempInt2 = 0;

  for(i=0;i<PageByte;i+=2)
  {

#ifdef RAMPZ_FLAG    	    
	TempInt = pgm_read_word_far(PageAddress + (unsigned long)i);
#else    	
  	TempInt = pgm_read_word(PageAddress + i);
#endif
	TempInt2 = PageBuffer[i] + ((unsigned int)(PageBuffer[i+1]<<8));
	
	if(TempInt != TempInt2) return 0;
  }
  return 1;

}




/*****************************************************************************
  RUTINE......: AutoFindBaudrate
  Function....: Auto-find baudrate if BAUDRATE is undefine
****************************************************************************/
char AutoFindBaudrate(void)
{
  // ڵ  ӵ O
/*
  unsigned char i; 

  #ifdef BAUDRATE
  UBRRL = BAUDRATE;
  #else

  for (i = 0; i < 255; ++i)
  {
    UBRRL = i;
    TxChar(0x55);
    Wait(10);
    if(RxChar() == 0x55) break;
  }
  if (i == 255 ) return 0;
  else return 1;

  #endif
*/

  RxWait = 300;		// Defualt delay time

  #ifdef BAUDRATE
  UBRRL = BAUDRATE;

  if(BAUDRATE == B115200) RxWait = 100;
  if(BAUDRATE == B57600) RxWait = 150;
  if(BAUDRATE == B38400) RxWait = 200;
  if(BAUDRATE == B19200) RxWait = 250;
  if(BAUDRATE == B9600) RxWait = 300;
  Wait(RxWait);
  RxChar();
  return 1;

  #else
  //RxWait = 100;
  UBRRL = B115200;	// 1byte = 69us
  if(AutoFindTx(RxWait)) return 1;

  //RxWait = 150;
  UBRRL = B57600;	// 1byte = 139us
  if(AutoFindTx(RxWait)) return 1;

  //RxWait = 200;
  UBRRL = B38400;	// 1byte = 208us
  if(AutoFindTx(RxWait)) return 1;

  //RxWait = 250;
  UBRRL = B19200;	// 1byte = 417us
  if(AutoFindTx(RxWait)) return 1;

  //RxWait = 300;
  UBRRL = B9600;	// 1byte = 833us
  if(AutoFindTx(RxWait)) return 1;

  return 0;		//  ӵ O ǻ
  #endif
}


char AutoFindTx(int wait_time)
{
  Wait(wait_time);
  RxChar();

  TxChar(AUTO_BAUDRATE_PING_CHAR);	// Auto BaudRate PING!!!
  Wait(wait_time);
  if(RxChar() == AUTO_BAUDRATE_PING_CHAR) return 1;
  else return 0;
}
 

  





/*****************************************************************************
  RUTINE......: EEpromLoad
  Function....: EEprom Programing Code
****************************************************************************/
#ifdef EEPROM
void EEpromLoad()
{
  unsigned char ByteAddressHigh;
  unsigned char ByteAddressLow;
  unsigned int ByteAddress;
  unsigned char Data;
  unsigned char LocalCheckSum;
  unsigned char CheckSum;


  TxChar(EEPROM_PROGRAM_CHAR);	// EEPROM α׷
  TxChar(READY_CHAR);			// ȣƮ  ͸ ϶..
  while (1)
  {
    LocalCheckSum = 0;

    while(!IsChar());
    ByteAddressHigh = RxChar();
    LocalCheckSum += ByteAddressHigh;

    while(!IsChar());
    ByteAddressLow = RxChar();
    LocalCheckSum += ByteAddressLow;

    ByteAddress = ((unsigned int)ByteAddressHigh<<8)+ByteAddressLow;

    if(ByteAddress == 0xffff) return;

    while(!IsChar());
    Data = RxChar();
    LocalCheckSum += Data;

    while(!IsChar());
    CheckSum = RxChar();

    if (CheckSum == LocalCheckSum)
    {
      EEPROMwrite(ByteAddress, Data);
      if (EEPROMread(ByteAddress) == Data) TxChar(LINE_COMPLETE_CHAR);	// ̻, Next data..
      else TxChar(CF_ERROR_CHAR);	// ,  䱸
    }
    else
    {
      TxChar(CS_ERROR_CHAR);		// ,  䱸
    }
  }
}
#endif



/*****************************************************************************
  SUB-RUTINE..: EEPROMwrite
  Function....: EEPROM Ÿ 
			    location = ּ , byte =  Ÿ
******************************************************************************/
#ifdef EEPROM
void EEPROMwrite( int location, unsigned char byte)
{
  while (EECR & 0x02);		// Wait until any earlier write is done
  EEAR = location;
  EEDR = byte;
  EECR |= 0x04;				// Set MASTER WRITE enable
  EECR |= 0x02;				// Set WRITE strobe
}
#endif
/*****************************************************************************
  SUB-RUTINE..: EEPROMread
  Function....: EEPROM Ÿ б
			    location = ּ , Ÿ ϵȴ.
******************************************************************************/
#ifdef EEPROM
unsigned char EEPROMread( int location)
{
  while (EECR & 0x02);
  EEAR = location;
  EECR |= 0x01;				// Set READ strobe
  return (EEDR);			// Return byte
}
#endif




/*****************************************************************************
  RUTINE......: LockBit
  Function....: LockBit Code
****************************************************************************/
#ifdef LOCKBIT
void LockBit(void)
{
  unsigned char LockSet,CheckBuff;

  TxChar(LOCKBIT_PROGRAM_CHAR);

  while(!IsChar());
  LockSet = RxChar();	// LockBit Ÿ

  while(!IsChar());		// üũ Ÿ
  CheckBuff = RxChar();
  if(LockSet == 0xFF && CheckBuff == 0xFF) return;
  CheckBuff = ~CheckBuff;
  //if (LockSet == CheckBuff) write_lock_bits(LockSet);
  if (LockSet == CheckBuff) boot_lock_bits_set(LockSet);
}
#endif


/*****************************************************************************
  RUTINE......: SettingBitRead
  Function....: FusesBit LockBit   
****************************************************************************/
#ifdef SETTINGBIT
void SettingBitRead(void)
{
  // FusesBit LockBit   
  TxChar(boot_lock_fuse_bits_get(GET_LOW_FUSE_BITS));	// address to read the low fuse bits
  TxChar(boot_lock_fuse_bits_get(GET_HIGH_FUSE_BITS));	// address to read the high fuse bits
  TxChar(boot_lock_fuse_bits_get(GET_EXTENDED_FUSE_BITS));	// address to read the extended fuse bits
  TxChar(boot_lock_fuse_bits_get(GET_LOCK_BITS));	// address to read the lock bits
}
#endif


/*****************************************************************************
  RUTINE......: ExecCode
  Function....: α׷ ..
****************************************************************************/
void ExecCode(void)
{
  #ifdef RAMPZ_FLAG
  RAMPZ = 0;
  #endif

  #ifdef INTVECREG
  INTVECREG = 0x01;		// Enable interrupt vector select
  INTVECREG = 0x00;		// Move interrupt vector to flash
  #endif
  
  TxChar(FILE_COMPLETE_CHAR);	// file complete

  //asm("jmp 0x0000");	// Run application code

	#ifdef __AVR_MEGA__ 
	#define XJMP "jmp" 
	#else 
	#define XJMP "rjmp" 
	#endif 
	asm(XJMP" 0x0000"); // Run application code 

}



int main(void)
{
/*
#ifdef  _RX_INLINE
  unsigned char i;
#endif
*/
  unsigned char i;

  asm("cli");				// disable all interrupts

  Wait(10);

  PULLUPPORT = PULLUPPIN;	// Pull up on RX line

  //Wait(100);
  Wait(300);

  UCSRB = 0x00;				// disable while setting baud rate
  UCSRA = 0x00;
  UCSRC = 0x86;				// Asyn,NoParity,1StopBit,8Bit,
  UBRRH = 0x00;				// set baud rate hi
  UCSRB = 0x18;				// Rx enable Tx Enable

  if(!AutoFindBaudrate()) ExecCode();
  //UBRRL = B9600;



/*
	TxChar(boot_lock_fuse_bits_get(GET_LOW_FUSE_BITS));	// address to read the low fuse bits
	TxChar(boot_lock_fuse_bits_get(GET_HIGH_FUSE_BITS));	// address to read the high fuse bits
	TxChar(boot_lock_fuse_bits_get(GET_EXTENDED_FUSE_BITS));	// address to read the extended fuse bits
	TxChar(boot_lock_fuse_bits_get(GET_LOCK_BITS));	// address to read the lock bits
*/

/*
#ifdef  _RX_INLINE
  i = RxChar();
#else
  RxChar();
#endif
*/
  i = RxChar();	// dummy read......

  Wait(500);

  TxChar(BOOTLOADER_ACTIVE_CHAR);	// Ʈδ νĹ(BOOTLOADER_ACTIVE_CHAR) ^ ۽  
  // while(!IsChar());   ʴ  ׻ ȣƮα׷ ʰ ̼ α׷ ɼֱ⶧̴..
  Wait(RxWait);
  if(RxChar() == BOOTLOADER_JUMP_CHAR)
  { 
	SendDeviceID();			// Target MCU  
    Wait(200);

/*
    #ifdef SETTINGBIT
    SettingBitRead();		// FusesBit LockBit   
    #endif
*/
    FlashLoad();			//  Ÿ ε

    Wait(200);
    #ifdef EEPROM
    EEpromLoad();
    #endif
  
	Wait(200);
    #ifdef LOCKBIT
    LockBit();
    #endif
  }

  ExecCode();
}
/* End of main program */

